import React from 'react';

import { RESOLUTION_OPTIONS } from '@/modules/feeds/Editor/constants';

import type { GeneralSizeProp } from '@/mui/types';

import { filterOptionsByType } from '@/modules/feeds/Editor/helpers';
import { resolutionSelector, typeSelector } from '@/modules/feeds/Editor/redux/selectors';
import { setAction } from '@/modules/feeds/Editor/redux/slices';

import { useFormSettings } from '@/modules/@common/Form';
import { useAppDispatch, useAppSelector } from '@/modules/@common/store/hooks';
import { MenuItem, Select } from '@/mui/components';

type PropTypes = {
  disabled?: boolean;
};

function Resolution({ disabled = false }: PropTypes) {
  const dispatch = useAppDispatch();
  const { size } = useFormSettings();

  const resolution = useAppSelector(resolutionSelector);
  const type = useAppSelector(typeSelector);

  if (!type) return null;

  return (
    <Select
      // placeholder="Select Resolution"
      size={size as GeneralSizeProp}
      value={resolution}
      disabled={disabled}
      onChange={(e) => dispatch(setAction({ resolution: e.target.value as typeof resolution }))}
    >
      {filterOptionsByType(RESOLUTION_OPTIONS, type).map((option) => (
        <MenuItem key={option.value} value={option.value}>
          {option.label}
        </MenuItem>
      ))}
    </Select>
  );
}

export default Resolution;
